[gcode_macro _CLIENT_EXTRUDE]
description: Extrudes, if the extruder is hot enough
gcode:
    {% set client = printer['gcode_macro _CLIENT_VARIABLE']|default({}) %}
    {% set use_fw_retract = (client.use_fw_retract|default(false)|lower == 'true') and (printer.firmware_retraction is defined) %}
    {% set length = params.LENGTH|default(client.unretract)|default(1.0)|float %}
    {% set speed = params.SPEED|default(client.speed_unretract)|default(35) %}
    {% set absolute_extrude = printer.gcode_move.absolute_extrude %}

    {% if printer.extruder.can_extrude %}
    {% if use_fw_retract %}
    {% if length < 0 %}
    G10
    {% else %}
    G11
    {% endif %}
    {% else %}
    M83
    G1 E{length} F{(speed|float|abs) * 60}
    {% if absolute_extrude %}
    M82
    {% endif %}
    {% endif %}
    {% else %}
    {action_respond_info("Extruder not hot enough")}
    {% endif %}